﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class BaseSCFree: MonoBehaviour
{
    public GameObject panelOrigin;
    public GameObject playAreaOrigin;
    public GameObject[] panels;
    public GameObject selectedPanelOrigin;
    public GameObject[] selectedPanels;

    private bool startBtnSelect;

    // Start is called before the first frame update
    void Start()
    {
        Prm.soloMode = true;
        this.gameObject.AddComponent<CommonSC>();
        // Scene読込時は必ずセーブを読み込むようにしておく
        Prm.savedataPatternType = PlayerPrefs.GetInt("panelType", 0);
        Prm.savedataSoundType = PlayerPrefs.GetInt("soundType", 0);

        Prm.selectFlg = false;
        startBtnSelect = false;
        Prm.selectedList = new Color[0];
        Prm.panelLiveFlg = new bool[4, 3];

        GetComponent<CommonSC>().SetPanel(panels, panelOrigin, playAreaOrigin);
        GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);
    }

    // Update is called once per frame
    void Update()
    {
    }
    public void mouseDown()
    {
        Prm.selectFlg = true;
    }
    public void mouseUp()
    {
        Prm.selectFlg = false;
        // playmodeの場合は正誤判定を実施
        CheckAnswer();
    }


    public void CheckAnswer()
    {
        switch (GetComponent<CommonSC>().CheckAnswerMain())
        {
            case -1:// 誤り 
                // 何もしない
                break;
            case 1:// 完成
                   // 初期化して問題再作成
                GetComponent<CommonSC>().MakeAnswerPanel(true);
                GetComponent<CommonSC>().MakeSelectListAnime(true);
                GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();
                GetComponent<CommonSC>().SetPanel(panels, panelOrigin, playAreaOrigin);
                GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);

                break;
            case 0:// 未完成の場合
                   // 何もしない
                break;
        }
    }
    public void reset()
    {
        GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();
        GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);
        for (int x = 0; x < 4; x++)
        {
            for (int y = 0; y < 3; y++)
            {
                Prm.panelLiveFlg[x, y] = true;
            }
        }
        foreach (Transform n in GameObject.Find("PlayArea").transform.Find("panels").transform)
        {
            Color.RGBToHSV(n.gameObject.transform.GetComponent<Renderer>().material.color, out float H, out float _, out float _);
            n.gameObject.transform.GetComponent<Renderer>().material.color = Color.HSVToRGB(H, 0.70f, 1f);
        }
        GameObject.Find("PlayArea").transform.Find("StartPoint").transform.position = new Vector3(10f, 10f, 0);
        GameObject.Find("PlayArea").transform.GetComponent<LineRenderer>().enabled = false;
        Prm.selectFlg = false;
    }
    public void change()
    {
        GetComponent<CommonSC>().MakeAnswerPanel(false);
        GetComponent<CommonSC>().MakeSelectListAnime(false);
        GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();
        GetComponent<CommonSC>().SetPanel(panels, panelOrigin, playAreaOrigin);
        GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);
    }
    public void btnClick()
    {
        startBtnSelect = true;
    }
    public void Exit()
    {
        Debug.Log("Scene遷移");
        SceneManager.LoadScene("Menu");
    }
}
