﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class BaseSCSoloNomal : MonoBehaviour
{
    public GameObject panelOrigin;
    public GameObject playAreaOrigin;
    public GameObject[] panels;
    public GameObject selectedPanelOrigin;
    public GameObject[] selectedPanels;

    private int highScore;
    private bool startBtnSelect;
    private DateTime startCountDownTime;
    private int maxCombo;
    private int score;


    // Start is called before the first frame update
    void Start()
    {
        Prm.soloMode = true;
        this.gameObject.AddComponent<CommonSC>();
        // Scene読込時は必ずセーブを読み込むようにしておく
        Prm.savedataPatternType = PlayerPrefs.GetInt("panelType", 0);
        Prm.savedataSoundType = PlayerPrefs.GetInt("soundType", 0);

        // ハイスコアをロード
        highScore = PlayerPrefs.GetInt("highScore", 0);

        Prm.selectFlg = false;
        startBtnSelect = false;
        Prm.mode = 0;
        Prm.timer = 0;
        Prm.selectedList = new Color[0];
        Prm.panelLiveFlg = new bool[4, 3];
    }

    // Update is called once per frame
    void Update()
    {
        switch (Prm.mode)
        {
            case 0://待機画面
                GameObject.Find("text").GetComponent<Text>().text = "HIGHSCORE:" + highScore;
                if (startBtnSelect)
                {
                    startBtnSelect = false;
                    startCountDownTime = DateTime.Now;
                    Prm.mode = 1;
                    // ボタンを非表示&無効にする
                    GameObject.Find("START").GetComponent<Text>().text = "";
                    GameObject.Find("StartBtn").GetComponent<BoxCollider2D>().enabled = false;
                }
                break;
            case 1://STARTカウントダウン
                GameObject.Find("text").GetComponent<Text>().text = "HIGHSCORE:" + highScore;
                Prm.timer += Time.deltaTime;
                GameObject.Find("startCountDown").GetComponent<Text>().text = ((int)((float)Prm.TIME_START_COUNT + 1 - Prm.timer)).ToString();
                if (Prm.timer >= Prm.TIME_START_COUNT)
                {
                    Prm.timer = 0;
                    Prm.mode = 2;
                    GameObject.Find("startCountDown").GetComponent<Text>().text = "";
                    GetComponent<CommonSC>().SetPanel(panels, panelOrigin,playAreaOrigin);
                    GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);
                    // スコアとコンボを初期化
                    Prm.combo = 0;
                    maxCombo = 0;
                    score = 0;
                }
                break;
            case 2://play画面
                Prm.timer += Time.deltaTime;

                String textBf = "time:";
                textBf = textBf + ((int)((float)Prm.TIME_SOLO_TIME_LIMIT - Prm.timer)).ToString();
                textBf = textBf + "   score:" + score;
                textBf = textBf + "   combo:" + Prm.combo;
                GameObject.Find("text").GetComponent<Text>().text = textBf;

                if (Prm.timer >= Prm.TIME_SOLO_TIME_LIMIT)
                {
                    Prm.timer = 0;
                    Prm.mode = 3;
                    Prm.selectFlg = false;

                    // タイマー0時に回答が完成していた場合のみtrueで解答エリアを生成＆得点も加算
                    if (GetComponent<CommonSC>().CheckAnswerMain() == 1)
                    {
                        GetComponent<CommonSC>().MakeAnswerPanel(true);
                        GetComponent<CommonSC>().MakeSelectListAnime(true);
                        addScoreAndCombo();
                    }
                    else
                    {
                        GetComponent<CommonSC>().MakeAnswerPanel(false);
                        GetComponent<CommonSC>().MakeSelectListAnime(false);
                    }

                    GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();

                    GameObject.Find("TIMEUP").GetComponent<Text>().enabled = true;
                    GameObject.Find("RETRY").GetComponent<Text>().enabled = true;
                    GameObject.Find("RetryBtn").GetComponent<BoxCollider2D>().enabled = true;
                }
                break;
            case 3://timeup&retry画面
                GameObject.Find("text").GetComponent<Text>().text = "HIGHSCORE:" + highScore
                    + "\r\n\r\n"
                    + "SCORE:" + score
                    + "\r\nMAX COMBO:" + maxCombo;
                Prm.selectFlg = false;
                GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();

                if (startBtnSelect)
                {
                    startBtnSelect = false;
                    startCountDownTime = DateTime.Now;
                    Prm.mode = 1;
                    // ボタンを非表示&無効にする
                    GameObject.Find("RetryBtn").GetComponent<BoxCollider2D>().enabled = false;
                    GameObject.Find("TIMEUP").GetComponent<Text>().enabled = false;
                    GameObject.Find("RETRY").GetComponent<Text>().enabled = false;
                    // 正解エリアを削除
                    Destroy(GameObject.Find("PlayArea(Clone)"));
                }
                break;
            default://例外
                break;
        }

    }



    public void mouseDown()
    {
        Prm.selectFlg = true;
    }
    public void mouseUp()
    {
        Prm.selectFlg = false;
        // playmodeの場合は正誤判定を実施
        if (Prm.mode == 2) CheckAnswer();
    }

    private void addScoreAndCombo()
    {
        Prm.combo++;
        if (Prm.combo > maxCombo)
        {
            maxCombo = Prm.combo;
        }
        score += (int)(Math.Pow(2, Prm.combo - 1) * 10);
        // highScoreを超えた場合はセーブ
        if (score > highScore)
        {
            highScore = score;
            PlayerPrefs.SetInt("highScore", highScore);
        }
    }

    public void CheckAnswer()
    {
        switch (GetComponent<CommonSC>().CheckAnswerMain())
        {
            case -1:// 誤り 
                    // 初期化して問題再作成
                GetComponent<CommonSC>().MakeAnswerPanel(false);
                GetComponent<CommonSC>().MakeSelectListAnime(false);
                GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();
                GetComponent<CommonSC>().SetPanel(panels,panelOrigin,playAreaOrigin);
                GetComponent<CommonSC>().MakeSelectedList(selectedPanels,selectedPanelOrigin);
                // コンボリセット
                Prm.combo = 0;
                break;
            case 1:// 完成
                   // 初期化して問題再作成
                GetComponent<CommonSC>().MakeAnswerPanel(true);
                GetComponent<CommonSC>().MakeSelectListAnime(true);
                GameObject.Find("SelectedList").GetComponent<SelectedListSC>().DestroyAllChilds();
                GetComponent<CommonSC>().SetPanel(panels, panelOrigin,playAreaOrigin);
                GetComponent<CommonSC>().MakeSelectedList(selectedPanels, selectedPanelOrigin);
                // スコア＆コンボ加算
                addScoreAndCombo();
                break;
            case 0:// 未完成の場合
                   // 何もしない
                break;
        }
    }
    public void btnClick()
    {
        startBtnSelect = true;
    }
    public void Exit()
    {
        Debug.Log("Scene遷移");
        SceneManager.LoadScene("Menu");
    }
}
