﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CommonHexSC : MonoBehaviour
{
    // randomに取得したパターンでpanelを配置する
    public void SetPanel(GameObject[] panels, GameObject panelOrigin, GameObject playAreaOrigin)
    {
        // PlayAreaを作成
        GameObject playArea = Instantiate(playAreaOrigin);
        playArea.name = "PlayArea";
        // 最初にガンギマ色を設定
        Prm.colorABCD = new Color[4];
        float rnd = (float)(UnityEngine.Random.Range(0, 1000f)) / 1000f;
        for (int i = 0; i < Prm.colorABCD.Length; i++)
        {
            Prm.colorABCD[i] = UnityEngine.Color.HSVToRGB(rnd, 0.70f, 1);
            rnd += 1f / (Prm.colorABCD.Length);
            if (rnd > 1f) rnd -= 1f;
        }
        // パネルに模様を付ける場合のパターン用乱数を取得
        int patternRnd = (int)UnityEngine.Random.Range(0, 4);

        int[] pattern = GingaPattern.random();
        for (int i = 0; i < panels.Length; i++)
        {
            panels[i].GetComponent<PanelScriptHex>().patternRnd = patternRnd;
            Prm.panelLiveFlg[i % 4, i / 4] = true;
        }
    }

    // 選択済み色の表示用パネルを作成
    public void MakeSelectedList(GameObject[] selectedPanels, GameObject selectedPanelOrigin)
    {
        // 選択済みカラー保持用リストを初期化
        Prm.selectedList = new Color[0];

        // 選択済み色表示用パネルを初期化
        selectedPanels = new GameObject[12];
        for (int i = 0; i < selectedPanels.Length; i++)
        {
            selectedPanels[i] = Instantiate(selectedPanelOrigin);
            selectedPanels[i].transform.localScale = new Vector3(5f / 12f, 5f / 12f, 0);
            selectedPanels[i].transform.position = new Vector3(((float)(i-7) - 5.5f) * 5f / 12f, 2.7f-5f/6f, 0);
            if (i < 7) selectedPanels[i].transform.position = new Vector3(((float)(i - 4) - 5.5f) * 5f / 12f, 2.7f - 5f / 12f, 0);
            if (i < 4) selectedPanels[i].transform.position = new Vector3(((float)i - 5.5f) * 5f / 12f, 2.7f, 0);
            // 非活性状態にしておく
            selectedPanels[i].GetComponent<Renderer>().enabled = false;
            // SelectedListの子供にしておく
            selectedPanels[i].transform.parent = GameObject.Find("SelectedList").transform;
        }
        // Prmに紐づける
        Prm.selectedPanels = selectedPanels;
    }
    // 解答確認(誤り：-1、未完成：0、完成：1)
    public int CheckAnswerMain(GameObject g)
    {
        // ガンギマ色そのままパターン
        bool bf = checkGANGIMA(Prm.colorABCD[0], Prm.colorABCD[1], Prm.colorABCD[2], Prm.colorABCD[3]);
        // ギンガマ色パターン
        bool bf2 = checkGANGIMA(Prm.colorABCD[2], Prm.colorABCD[1], Prm.colorABCD[0], Prm.colorABCD[3]);
        
        if (!bf && !bf2) return -1;
        if (Prm.selectedList.Length == 12) return 1;

        // 終点から先に行き先が無い場合return -1(継続不可能な場合)
        // ※選択済みのlistが1以下の場合は必ず行先が有るので継続可能としてreturn 0
        if (Prm.selectedList.Length <= 1) return 0;
        // todo 詰み判定を作る必要あり
        if (!checkStalemate(g)) return -1;
        return 0;
    }
    private bool checkStalemate(GameObject g)
    {
        if (g == null) return false;
        GameObject g2 = GameObject.Find("PlayAreaHex");
        if (g2 == null) return false;
        LineRenderer line = g2.transform.GetComponent<LineRenderer>();
        Vector3 pos = line.GetPosition(line.positionCount - 1);
        double dist = 10000;
        Transform panels = GameObject.Find("PlayAreaHex").transform.Find("panels");
        for (int i = 0; i < panels.GetChildCount(); i++)
        {
            Transform t = panels.GetChild(i).transform;
            //色が暗い場合はスキップ
            Color.RGBToHSV(t.GetComponent<Renderer>().material.color, out _, out _, out float V);
            if (V <= 0.5f) continue;
            double bf = distance(pos, t.position);
            if (bf != 0 && dist > bf) dist = bf;
        }
        if (dist > 1.5f) return false;
        return true;
    }

    private double distance(Vector3 pos1, Vector3 pos2)
    {
        float x = pos1.x - pos2.x;
        float y = pos1.y - pos2.y;
        float z = pos1.z - pos2.z;
        x *= x;
        y *= y;
        z *= z;
        float rtn = x + y + z;
        return Math.Pow(rtn, 0.5);
    }
    private bool checkGANGIMA(Color a, Color b, Color c, Color d)
    {
        Color[] answerColorList = {
            a,b,a,b,c,c,b,c,b,a,d,b
        };
        // selectedListの内容をチェック
        bool flg = true;
        for (int i = 0; i < Prm.selectedList.Length; i++)
        {
            if (Prm.selectedList[i] != answerColorList[i])
            {
                flg = false;
                break;
            }
        }
        return flg;
    }

    public void MakeAnswerPanel(bool answered)
    {
        GameObject.Find("PlayAreaHex").GetComponent<PlayAreaHexSC>().ChangeToAnswerMode(answered);
    }
    public void MakeSelectListAnime(bool correct)
    {
        // SelectedList(Clone)が既に存在する場合は削除
        Destroy(GameObject.Find("SelectedList(Clone)"));
        // SelectedListの内容を複製
        GameObject original = GameObject.Find("SelectedList");
        GameObject copied = UnityEngine.Object.Instantiate(original) as GameObject;
        if (correct) copied.GetComponent<SelectedListSC>().mode = 1;
        if (!correct) copied.GetComponent<SelectedListSC>().mode = -1;
    }


}
