﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CommonSC : MonoBehaviour
{
    // randomに取得したパターンでpanelを配置する
    public void SetPanel(GameObject[] panels,GameObject panelOrigin,GameObject playAreaOrigin)
    {
        // PlayAreaを作成
        GameObject playArea = Instantiate(playAreaOrigin);
        playArea.name = "PlayArea";
        // 最初にガンギマ色を設定
        Prm.colorABCD = new Color[4];
        float rnd = (float)(UnityEngine.Random.Range(0, 1000f)) / 1000f;
        for (int i = 0; i < Prm.colorABCD.Length; i++)
        {
            Prm.colorABCD[i] = UnityEngine.Color.HSVToRGB(rnd, 0.70f, 1);
            rnd += 1f / (Prm.colorABCD.Length);
            if (rnd > 1f) rnd -= 1f;
        }
        // パネルに模様を付ける場合のパターン用乱数を取得
        int patternRnd = (int)UnityEngine.Random.Range(0, 4);

        int[] pattern = GingaPattern.random();
        panels = new GameObject[12];

        for (int i = 0; i < panels.Length; i++)
        {
            panels[i] = Instantiate(panelOrigin);
            panels[i].GetComponent<PanelScript>().patternRnd = patternRnd;
            panels[i].transform.position = new Vector3(i % 4 - 1.5f, i / 4 - 1, 0);
            panels[i].GetComponent<PanelScript>().x = i % 4;
            panels[i].GetComponent<PanelScript>().y = i / 4;
            panels[i].GetComponent<PanelScript>().no = pattern[i];
            Prm.panelLiveFlg[i % 4, i / 4] = true;
            // PlayArea-panelsの子供にしておく
            panels[i].transform.parent = GameObject.Find("PlayArea").transform.Find("panels").transform;
        }
    }

    // 選択済み色の表示用パネルを作成
    public void MakeSelectedList(GameObject[] selectedPanels,GameObject selectedPanelOrigin)
    {
        // 選択済みカラー保持用リストを初期化
        Prm.selectedList = new Color[0];

        // 選択済み色表示用パネルを初期化
        selectedPanels = new GameObject[12];
        for (int i = 0; i < selectedPanels.Length; i++)
        {
            selectedPanels[i] = Instantiate(selectedPanelOrigin);
            selectedPanels[i].transform.localScale = new Vector3(5f / 12f, 5f / 12f, 0);
            selectedPanels[i].transform.position = new Vector3(((float)(i - 7) - 5.5f) * 5f / 12f, 2.7f - 5f / 6f, 0);
            if (i < 7) selectedPanels[i].transform.position = new Vector3(((float)(i - 4) - 5.5f) * 5f / 12f, 2.7f - 5f / 12f, 0);
            if (i < 4) selectedPanels[i].transform.position = new Vector3(((float)i - 5.5f) * 5f / 12f, 2.7f, 0);
            // 非活性状態にしておく
            selectedPanels[i].GetComponent<Renderer>().enabled = false;
            // SelectedListの子供にしておく
            selectedPanels[i].transform.parent = GameObject.Find("SelectedList").transform;
        }
        // Prmに紐づける
        Prm.selectedPanels = selectedPanels;
    }
    // 解答確認(誤り：-1、未完成：0、完成：1)
    public int CheckAnswerMain()
    {
        Color[] answerColorList = {
            Prm.colorABCD[0],
            Prm.colorABCD[1],
            Prm.colorABCD[0],
            Prm.colorABCD[1],
            Prm.colorABCD[2],
            Prm.colorABCD[2],
            Prm.colorABCD[1],
            Prm.colorABCD[2],
            Prm.colorABCD[1],
            Prm.colorABCD[0],
            Prm.colorABCD[3],
            Prm.colorABCD[1]
        };
        // selectedListの内容をチェック
        bool flg = true;
        for (int i = 0; i < Prm.selectedList.Length; i++)
        {
            if (Prm.selectedList[i] != answerColorList[i])
            {
                flg = false;
                break;
            }
        }
        if (!flg) return -1;
        if (Prm.selectedList.Length == 12) return 1;
        // 終点から先に行き先が無い場合return -1(継続不可能な場合)
        // ※選択済みのlistが1以下の場合は必ず行先が有るので継続可能としてreturn 0
        if (Prm.selectedList.Length <= 1) return 0;
        if (Prm.endPosX - 1 >= 0 && Prm.panelLiveFlg[Prm.endPosX - 1, Prm.endPosY]) return 0;
        if (Prm.endPosX + 1 <= 3 && Prm.panelLiveFlg[Prm.endPosX + 1, Prm.endPosY]) return 0;
        if (Prm.endPosY - 1 >= 0 && Prm.panelLiveFlg[Prm.endPosX, Prm.endPosY - 1]) return 0;
        if (Prm.endPosY + 1 <= 2 && Prm.panelLiveFlg[Prm.endPosX, Prm.endPosY + 1]) return 0;
        return -1;
    }
    public void MakeAnswerPanel(bool answered)
    {
        GameObject.Find("PlayArea").GetComponent<PlayAreaSC>().ChangeToAnswerMode(answered);
    }
    public void MakeSelectListAnime(bool correct)
    {
        // SelectedList(Clone)が既に存在する場合は削除
        Destroy(GameObject.Find("SelectedList(Clone)"));
        // SelectedListの内容を複製
        GameObject original = GameObject.Find("SelectedList");
        GameObject copied = UnityEngine.Object.Instantiate(original) as GameObject;
        if (correct) copied.GetComponent<SelectedListSC>().mode = 1;
        if (!correct) copied.GetComponent<SelectedListSC>().mode = -1;
    }


}
