﻿using Random = UnityEngine.Random;

public class GingaPattern
{
    private static int[] history;
    private readonly static int[,] data =
    {
    {0,1,2,3,7,6,5,4,8,9,10,11},		// 1	 A,B,A,B,C,B,C,C,B,A,D,B,		
	{0,1,2,3,9,8,7,4,10,11,6,5},		// 2	 A,B,A,B,A,B,C,C,D,B,B,C,		
	{0,1,2,3,9,10,11,4,8,7,6,5},		// 3	 A,B,A,B,A,D,B,C,B,C,B,C,		
	{0,1,2,3,11,8,7,4,10,9,6,5},		// 4	 A,B,A,B,B,B,C,C,D,A,B,C,		
	{0,1,2,11,5,4,3,10,6,7,8,9},		// 5	 A,B,A,B,C,C,B,D,B,C,B,A,		
	{0,1,4,5,11,2,3,6,10,9,8,7},		// 6	 A,B,C,C,B,A,B,B,D,A,B,C,		
	{0,1,8,9,3,2,7,10,4,5,6,11},		// 7	 A,B,B,A,B,A,C,D,C,C,B,B,		
	{0,1,10,9,3,2,11,8,4,5,6,7},		// 8	 A,B,D,A,B,A,B,B,C,C,B,C,		
	{0,1,10,11,3,2,9,8,4,5,6,7},		// 9	 A,B,D,B,B,A,A,B,C,C,B,C,		
	{0,5,6,7,1,4,9,8,2,3,10,11},		// 10	 A,C,B,C,B,C,A,B,A,B,D,B,		
	{0,5,6,7,1,4,11,8,2,3,10,9},		// 11	 A,C,B,C,B,C,B,B,A,B,D,A,		
	{0,5,6,11,1,4,7,10,2,3,8,9},		// 12	 A,C,B,B,B,C,C,D,A,B,B,A,		
	{0,7,8,9,1,6,5,10,2,3,4,11},		// 13	 A,C,B,A,B,B,C,D,A,B,C,B,		
	{0,9,8,7,1,10,11,6,2,3,4,5},		// 14	 A,A,B,C,B,D,B,B,A,B,C,C,		
	{0,9,10,11,1,8,7,6,2,3,4,5},		// 15	 A,A,D,B,B,B,C,B,A,B,C,C,		
	{0,11,8,7,1,10,9,6,2,3,4,5},		// 16	 A,B,B,C,B,D,A,B,A,B,C,C,		
	{0,11,10,9,1,4,5,8,2,3,6,7},		// 17	 A,B,D,A,B,C,C,B,A,B,B,C,		
	{1,0,5,6,2,3,4,7,11,10,9,8},		// 18	 B,A,C,B,A,B,C,C,B,D,A,B,		
	{1,0,7,8,2,5,6,9,3,4,11,10},		// 19	 B,A,C,B,A,C,B,A,B,C,B,D,		
	{1,0,9,8,2,11,10,7,3,4,5,6},		// 20	 B,A,A,B,A,B,D,C,B,C,C,B,		
	{1,0,11,10,2,5,6,9,3,4,7,8},		// 21	 B,A,B,D,A,C,B,A,B,C,C,B,		
	{1,2,3,4,0,9,8,5,11,10,7,6},		// 22	 B,A,B,C,A,A,B,C,B,D,C,B,		
// 	{1,2,5,6,0,3,4,7,11,10,9,8},		// 23	 B,A,C,B,A,B,C,C,B,D,A,B,	13	と同型
	{2,1,0,11,3,6,7,10,4,5,8,9},		// 24	 A,B,A,B,B,B,C,D,C,C,B,A,		
// 	{2,1,8,9,3,0,7,10,4,5,6,11},		// 25	 A,B,B,A,B,A,C,D,C,C,B,B,	7	と同型
// 	{2,1,10,9,3,0,11,8,4,5,6,7},		// 26	 A,B,D,A,B,A,B,B,C,C,B,C,	8	と同型
// 	{2,1,10,11,3,0,9,8,4,5,6,7},		// 27	 A,B,D,B,B,A,A,B,C,C,B,C,	27	と同型
	{2,3,4,5,1,8,7,6,0,9,10,11},		// 28	 A,B,C,C,B,B,C,B,A,A,D,B,		
	{2,3,4,5,1,10,9,6,0,11,8,7},		// 29	 A,B,C,C,B,D,A,B,A,B,B,C,		
	{2,3,4,5,1,10,11,6,0,9,8,7},		// 30	 A,B,C,C,B,D,B,B,A,A,B,C,		
	{2,3,4,11,1,6,5,10,0,7,8,9},		// 31	 A,B,C,B,B,B,C,D,A,C,B,A,		
	{2,3,6,7,1,4,5,8,0,11,10,9},		// 32	 A,B,B,C,B,C,C,B,A,B,D,A,		
	{2,3,8,9,1,4,7,10,0,5,6,11},		// 33	 A,B,B,A,B,C,C,D,A,C,B,B,		
	{2,3,10,9,1,4,11,8,0,5,6,7},		// 34	 A,B,D,A,B,C,B,B,A,C,B,C,		
	{2,3,10,11,1,4,9,8,0,5,6,7},		// 35	 A,B,D,B,B,C,A,B,A,C,B,C,		
	{3,2,1,0,4,5,6,7,11,10,9,8},		// 36	 B,A,B,A,C,C,B,C,B,D,A,B,		
	{3,2,1,0,4,7,8,9,5,6,11,10},		// 37	 B,A,B,A,C,C,B,A,C,B,B,D,		
	{3,2,1,0,4,7,8,11,5,6,9,10},		// 38	 B,A,B,A,C,C,B,B,C,B,A,D,		
	{3,2,1,0,4,11,10,9,5,6,7,8},		// 39	 B,A,B,A,C,B,D,A,C,B,C,B,		
	{3,2,11,10,4,1,0,9,5,6,7,8},		// 40	 B,A,B,D,C,B,A,A,C,B,C,B,		
	{3,4,5,6,2,1,0,7,11,10,9,8},		// 41	 B,C,C,B,A,B,A,C,B,D,A,B,		
	{3,4,5,6,2,11,10,7,1,0,9,8},		// 42	 B,C,C,B,A,B,D,C,B,A,A,B,		
	{3,4,7,8,2,5,6,9,1,0,11,10},		// 43	 B,C,C,B,A,C,B,A,B,A,B,D,		
	{3,4,11,10,2,5,6,9,1,0,7,8},		// 44	 B,C,B,D,A,C,B,A,B,A,C,B,		
	{4,3,0,11,5,2,1,10,6,7,8,9},		// 45	 C,B,A,B,C,A,B,D,B,C,B,A,		
	{4,3,2,1,5,8,9,0,6,7,10,11},		// 46	 C,B,A,B,C,B,A,A,B,C,D,B,		
// 	{4,3,2,11,5,0,1,10,6,7,8,9},		// 47	 C,B,A,B,C,A,B,D,B,C,B,A,	47	と同型
	{4,5,6,7,3,0,9,8,2,1,10,11},		// 48	 C,C,B,C,B,A,A,B,A,B,D,B,		
	{4,5,6,7,3,0,11,8,2,1,10,9},		// 49	 C,C,B,C,B,A,B,B,A,B,D,A,		
// 	{4,5,6,7,3,2,9,8,0,1,10,11},		// 50	 C,C,B,C,B,A,A,B,A,B,D,B,	48	と同型
// 	{4,5,6,7,3,2,11,8,0,1,10,9},		// 51	 C,C,B,C,B,A,B,B,A,B,D,A,	49	と同型
	{4,5,6,11,3,0,7,10,2,1,8,9},		// 52	 C,C,B,B,B,A,C,D,A,B,B,A,		
// 	{4,5,6,11,3,2,7,10,0,1,8,9},		// 53	 C,C,B,B,B,A,C,D,A,B,B,A,	52	と同型
	{4,5,8,9,3,6,7,10,2,1,0,11},		// 54	 C,C,B,A,B,B,C,D,A,B,A,B,		
	{5,4,1,0,6,3,2,11,7,8,9,10},		// 55	 C,C,B,A,B,B,A,B,C,B,A,D,		
	{5,4,3,2,6,7,8,1,11,10,9,0},		// 56	 C,C,B,A,B,C,B,B,B,D,A,A,		
	{5,4,3,2,6,9,10,1,7,8,11,0},		// 57	 C,C,B,A,B,A,D,B,C,B,B,A,		
	{5,4,3,2,6,11,10,1,7,8,9,0},		// 58	 C,C,B,A,B,B,D,B,C,B,A,A,		
	{5,6,7,8,4,1,0,9,3,2,11,10},		// 59	 C,B,C,B,C,B,A,A,B,A,B,D,		
	{5,6,7,8,4,11,10,9,3,2,1,0},		// 60	 C,B,C,B,C,B,D,A,B,A,B,A,		
	{5,6,9,10,4,7,8,11,3,2,1,0},		// 61	 C,B,A,D,C,C,B,B,B,A,B,A,		
	{5,6,11,10,4,7,8,9,3,2,1,0},		// 62	 C,B,B,D,C,C,B,A,B,A,B,A,		
	{6,5,0,1,7,4,3,2,8,9,10,11},		// 63	 B,C,A,B,C,C,B,A,B,A,D,B,		
// 	{6,5,2,1,7,4,3,0,8,9,10,11},		// 64	 B,C,A,B,C,C,B,A,B,A,D,B,	63	と同型
	{6,5,4,3,7,0,1,2,8,9,10,11},		// 65	 B,C,C,B,C,A,B,A,B,A,D,B,		
	{6,5,4,3,7,10,11,2,8,9,0,1},		// 66	 B,C,C,B,C,D,B,A,B,A,A,B,		
	{6,7,8,9,5,0,1,10,4,3,2,11},		// 67	 B,C,B,A,C,A,B,D,C,B,A,B,		
// 	{6,7,8,9,5,2,1,10,4,3,0,11},		// 68	 B,C,B,A,C,A,B,D,C,B,A,B,	67	と同型
	{6,7,8,9,5,4,3,10,0,1,2,11},		// 69	 B,C,B,A,C,C,B,D,A,B,A,B,		
	{6,7,10,11,5,8,9,0,4,3,2,1},		// 70	 B,C,D,B,C,B,A,A,C,B,A,B,		
	{7,6,3,2,8,5,4,1,9,10,11,0},		// 71	 C,B,B,A,B,C,C,B,A,D,B,A,		
	{7,6,5,0,8,9,4,1,11,10,3,2},		// 72	 C,B,C,A,B,A,C,B,B,D,B,A,		
	{7,6,5,0,8,11,4,1,9,10,3,2},		// 73	 C,B,C,A,B,B,C,B,A,D,B,A,		
	{7,6,5,4,8,9,0,3,11,10,1,2},		// 74	 C,B,C,C,B,A,A,B,B,D,B,A,		
// 	{7,6,5,4,8,9,2,3,11,10,1,0},		// 75	 C,B,C,C,B,A,A,B,B,D,B,A,	74	と同型
	{7,6,5,4,8,11,0,3,9,10,1,2},		// 76	 C,B,C,C,B,B,A,B,A,D,B,A,		
// 	{7,6,5,4,8,11,2,3,9,10,1,0},		// 77	 C,B,C,C,B,B,A,B,A,D,B,A,	76	と同型
	{7,8,9,0,6,11,10,1,5,4,3,2},		// 78	 C,B,A,A,B,B,D,B,C,C,B,A,		
	{7,8,9,10,6,3,2,11,5,4,1,0},		// 79	 C,B,A,D,B,B,A,B,C,C,B,A,		
	{7,8,11,0,6,9,10,1,5,4,3,2},		// 80	 C,B,B,A,B,A,D,B,C,C,B,A,		
	{8,7,0,1,9,6,5,2,10,11,4,3},		// 81	 B,C,A,B,A,B,C,A,D,B,C,B,		
	{8,7,4,3,9,6,5,2,10,11,0,1},		// 82	 B,C,C,B,A,B,C,A,D,B,A,B,		
	{8,7,6,5,9,0,1,4,10,11,2,3},		// 83	 B,C,B,C,A,A,B,C,D,B,A,B,		
	{8,7,6,5,9,10,11,4,0,1,2,3},		// 84	 B,C,B,C,A,D,B,C,A,B,A,B,		
	{8,9,0,1,7,10,11,2,6,5,4,3},		// 85	 B,A,A,B,C,D,B,A,B,C,C,B,		
	{8,9,10,11,7,0,1,2,6,5,4,3},		// 86	 B,A,D,B,C,A,B,A,B,C,C,B,		
	{8,9,10,11,7,4,3,0,6,5,2,1},		// 87	 B,A,D,B,C,C,B,A,B,C,A,B,		
// 	{8,9,10,11,7,4,3,2,6,5,0,1},		// 88	 B,A,D,B,C,C,B,A,B,C,A,B,	87	と同型
	{8,9,10,11,7,6,5,4,0,1,2,3},		// 89	 B,A,D,B,C,B,C,C,A,B,A,B,		
	{9,8,1,0,10,7,2,3,11,6,5,4},		// 90	 A,B,B,A,D,C,A,B,B,B,C,C,		
// 	{9,8,1,2,10,7,0,3,11,6,5,4},		// 91	 A,B,B,A,D,C,A,B,B,B,C,C,	90	と同型
	{9,8,3,2,10,7,4,1,11,6,5,0},		// 92	 A,B,B,A,D,C,C,B,B,B,C,A,		
	{9,8,5,4,10,7,6,3,11,0,1,2},		// 93	 A,B,C,C,D,C,B,B,B,A,B,A,		
	{9,8,7,0,10,5,6,1,11,4,3,2},		// 94	 A,B,C,A,D,C,B,B,B,C,B,A,		
	{9,8,7,6,10,1,0,5,11,2,3,4},		// 95	 A,B,C,B,D,B,A,C,B,A,B,C,		
// 	{9,8,7,6,10,1,2,5,11,0,3,4},		// 96	 A,B,C,B,D,B,A,C,B,A,B,C,	95	と同型
	{9,8,7,6,10,3,4,5,11,2,1,0},		// 97	 A,B,C,B,D,B,C,C,B,A,B,A,		
	{9,10,1,0,8,11,2,3,7,6,5,4},		// 98	 A,D,B,A,B,B,A,B,C,B,C,C,		
// 	{9,10,1,2,8,11,0,3,7,6,5,4},		// 99	 A,D,B,A,B,B,A,B,C,B,C,C,	98	と同型
	{9,10,3,2,8,11,4,1,7,6,5,0},		// 100	 A,D,B,A,B,B,C,B,C,B,C,A,		
	{9,10,11,0,8,5,4,1,7,6,3,2},		// 101	 A,D,B,A,B,C,C,B,C,B,B,A,		
	{10,9,6,5,11,8,7,4,0,1,2,3},		// 102	 D,A,B,C,B,B,C,C,A,B,A,B,		
	{10,9,8,7,11,2,3,6,0,1,4,5},		// 103	 D,A,B,C,B,A,B,B,A,B,C,C,		
	{10,11,0,1,9,6,5,2,8,7,4,3},		// 104	 D,B,A,B,A,B,C,A,B,C,C,B,		
	{10,11,2,3,9,0,1,4,8,7,6,5},		// 105	 D,B,A,B,A,A,B,C,B,C,B,C,		
	{10,11,4,3,9,6,5,2,8,7,0,1},		// 106	 D,B,C,B,A,B,C,A,B,C,A,B,		
	{10,11,6,5,9,8,7,4,0,1,2,3},		// 107	 D,B,B,C,A,B,C,C,A,B,A,B,		
	{11,0,1,2,10,7,6,3,9,8,5,4},		// 108	 B,A,B,A,D,C,B,B,A,B,C,C,		
	{11,0,3,4,10,1,2,5,9,8,7,6},		// 109	 B,A,B,C,D,B,A,C,A,B,C,B,		
	{11,2,1,0,10,3,4,5,9,8,7,6},		// 110	 B,A,B,A,D,B,C,C,A,B,C,B,		
// 	{11,2,3,4,10,1,0,5,9,8,7,6},		// 111	 B,A,B,C,D,B,A,C,A,B,C,B,	109	と同型
	{11,4,3,2,10,5,6,1,9,8,7,0},		// 112	 B,C,B,A,D,C,B,B,A,B,C,A,		
	{11,6,5,0,10,7,4,1,9,8,3,2},		// 113	 B,B,C,A,D,C,C,B,A,B,B,A,		
	{11,6,5,4,10,7,0,3,9,8,1,2},		// 114	 B,B,C,C,D,C,A,B,A,B,B,A,		
// 	{11,6,5,4,10,7,2,3,9,8,1,0},		// 115	 B,B,C,C,D,C,A,B,A,B,B,A,	114	と同型
	{11,10,1,0,8,9,2,3,7,6,5,4},		// 116	 B,D,B,A,B,A,A,B,C,B,C,C,		
// 	{11,10,1,2,8,9,0,3,7,6,5,4},		// 117	 B,D,B,A,B,A,A,B,C,B,C,C,	116	と同型
	{11,10,3,2,8,9,4,1,7,6,5,0},		// 118	 B,D,B,A,B,A,C,B,C,B,C,A,		
	{11,10,7,6,0,9,8,5,1,2,3,4},		// 119	 B,D,C,B,A,A,B,C,B,A,B,C,		
	{11,10,9,0,6,7,8,1,5,4,3,2},		// 120	 B,D,A,A,B,C,B,B,C,C,B,A,		
	{11,10,9,8,0,3,4,7,1,2,5,6},		// 121	 B,D,A,B,A,B,C,C,B,A,C,B,		
	{11,10,9,8,2,1,0,7,3,4,5,6},		// 122	 B,D,A,B,A,B,A,C,B,C,C,B,		
// 	{11,10,9,8,2,3,4,7,1,0,5,6},		// 123	 B,D,A,B,A,B,C,C,B,A,C,B,	121	と同型
	{11,10,9,8,4,5,6,7,3,2,1,0},		// 124	 B,D,A,B,C,C,B,C,B,A,B,A,		
    };
    public static int[] random()
    {
        int bf = (int)Random.Range(0, data.GetLength(0));
        int[] rtn = {
            data[bf,0],data[bf,1],data[bf, 2],data[bf, 3],
            data[bf,4],data[bf,5],data[bf, 6],data[bf, 7],
            data[bf,8],data[bf,9],data[bf,10],data[bf,11]
        };
        // 前回データがある場合、完全一致するか確認
        if (history != null)
        {
            bool sameFlg = true;
            for(int i = 0; i < history.Length; i++)
            {
                if (history[i]!=rtn[i])
                {
                    sameFlg = false;
                    break;
                }
            }
            // 完全一致しているなら取り直し
            if (sameFlg) return random();
        }
        history = rtn;
        return rtn;
    }
}