﻿using System;
using UnityEngine;
using UnityEngine.SceneManagement;

public class PanelScript : MonoBehaviour
{

    public int x;
    public int y;
    public int no;
    public int patternRnd;
    public GameObject mark;
    public Sprite dot_0;
    public Sprite dot_1;
    public Sprite dot_2;
    public Sprite dot_3;
    // ギンガマンの楽譜
    // F-F-AC-C-GG-
    // 0123456789ab
    public AudioSource Asharp;
    public AudioSource Csharp;
    public AudioSource Fsharp;
    public AudioSource Gsharp;
    private void playSound()
    {
        if (Prm.savedataSoundType != 1) return;
        if (no == 0 || no == 2) Fsharp.Play();
        if (no == 4) Asharp.Play();
        if (no == 7 || no == 5) Csharp.Play();
        if (no == 9 || no == 10) Gsharp.Play();
    }

    // Start is called before the first frame update
    void Start()
    {
        // パネルカラーにNoを反映
        InitPanelColor();
        // パネルパターンにNoを反映(パネル柄非表示モードの場合はデストロイ)
        InitPanelPattern();
    }
    private void InitPanelColor()
    {
        if (no == 0 || no == 2 || no == 9) GetComponent<Renderer>().material.color = Prm.colorABCD[0];
        if (no == 1 || no == 3 || no == 6 || no == 8 || no == 11) GetComponent<Renderer>().material.color = Prm.colorABCD[1];
        if (no == 4 || no == 5 || no == 7) GetComponent<Renderer>().material.color = Prm.colorABCD[2];
        if (no == 10) GetComponent<Renderer>().material.color = Prm.colorABCD[3];
    }
    private void InitPanelPattern()
    {
        if (Prm.savedataPatternType == 0)
        {
            Destroy(mark);
            return;
        }
        if (no == 0 || no == 2 || no == 9) ChangePattern(patternRnd+0);
        if (no == 1 || no == 3 || no == 6 || no == 8 || no == 11) ChangePattern(patternRnd + 1);
        if (no == 4 || no == 5 || no == 7) ChangePattern(patternRnd + 2);
        if (no == 10) ChangePattern(patternRnd + 3);
    }
    private void ChangePattern(int pattern)
    {
        if (pattern % 4 == 0) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_0;
        if (pattern % 4 == 1) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_1;
        if (pattern % 4 == 2) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_2;
        if (pattern % 4 == 3) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_3;
    }


    // Update is called once per frame
    void Update()
    {
    }
    public void SelectPanel()
    {
        PutAndChangeColor();
    }
    public void MouseDown()
    {
        Prm.selectFlg = true;
    }
    public void MouseUp()
    {
        PutAndChangeColor();
        if (!Prm.soloMode)
        {
            GameObject.Find("BaseSC").GetComponent<BaseSC>().CheckAnswer();
        }
        else
        {
            if (SceneManager.GetActiveScene().name == "SoloNomal")
            {
                GameObject.Find("BaseSC").GetComponent<BaseSCSoloNomal>().CheckAnswer();
            }
            else
            {
                GameObject.Find("BaseSC").GetComponent<BaseSCFree>().CheckAnswer();
            }
        }
        Prm.selectFlg = false;
    }
    // 
    public void PutAndChangeColor()
    {
        if (Prm.selectFlg && Prm.panelLiveFlg[x, y] && (AllPanelIsLive()||NearByEndPos()))
        {
            //最初の1枚目の場合startPosに設定
            if (AllPanelIsLive())
            {
                Prm.startPosX = x;
                Prm.startPosY = y;
                transform.root.gameObject.transform.Find("StartPoint").gameObject.transform.position = new Vector3(x - 1.5f, y - 1, 0);
                transform.root.gameObject.transform.Find("StartPoint").gameObject.SetActive(true);
                //lineの始点を決定
                transform.root.gameObject.GetComponent<LineRenderer>().enabled = true;
                transform.root.gameObject.GetComponent<LineRenderer>().positionCount = 1;
                transform.root.gameObject.GetComponent<LineRenderer>().SetPosition(0, new Vector3(x - 3f, y - 2f, 0));

            }
            else //2枚目以降の場合
            {
                transform.root.gameObject.GetComponent<LineRenderer>().positionCount+=1;
                transform.root.gameObject.GetComponent<LineRenderer>().SetPosition(
                    transform.root.gameObject.GetComponent<LineRenderer>().positionCount-1
                    , new Vector3(x - 3f, y - 2f, 0));
            }
            // selectListに追加
            Array.Resize(ref Prm.selectedList, Prm.selectedList.Length + 1);
            Prm.selectedList[Prm.selectedList.Length - 1] = gameObject.GetComponent<Renderer>().material.color;
            // selectedPanelListを活性化＆色更新
            Prm.selectedPanels[Prm.selectedList.Length - 1].GetComponent<Renderer>().enabled = true;
            Prm.selectedPanels[Prm.selectedList.Length - 1].GetComponent<Renderer>().material.color
                = Prm.selectedList[Prm.selectedList.Length - 1];

            // 選択したパネルのフラグ折り＆色変え＆EndPoint更新
            Prm.panelLiveFlg[x, y] = false;
            Prm.endPosX = x;
            Prm.endPosY = y;
            // パネル色を暗くする
            Color.RGBToHSV(gameObject.GetComponent<Renderer>().material.color, out float H, out _, out _);
            gameObject.GetComponent<Renderer>().material.color = Color.HSVToRGB(H, 0.70f, 0.5f);
            //サウンド設定に従い、対象の音を鳴らす
            playSound();
        }
    }

    public bool AllPanelIsLive()
    {
        for (int x = 0; x < 4; x++)
        {
            for (int y = 0; y < 3; y++)
            {
                if (Prm.panelLiveFlg[x, y] == false)
                {
                    return false;
                }
            }
        }
        return true;
    }

    public bool NearByEndPos()
    {
        if (x > 0 && Prm.endPosX == x - 1 && Prm.endPosY == y) return true;
        if (x < 4 - 1 && Prm.endPosX == x + 1 && Prm.endPosY == y) return true;
        if (y > 0 && Prm.endPosY == y - 1 && Prm.endPosX == x) return true;
        if (y < 3 - 1 && Prm.endPosY == y + 1 && Prm.endPosX == x) return true;
        return false;
    }

}
