﻿using System;
using UnityEngine;
using UnityEngine.SceneManagement;

public class PanelScriptHex : MonoBehaviour
{
    public int x;
    public int y;
    public int no;
    public int patternRnd;
    public GameObject mark;
    public Sprite dot_0;
    public Sprite dot_1;
    public Sprite dot_2;
    public Sprite dot_3;
    // ギンガマンの楽譜
    // F-F-AC-C-GG-
    // 0123456789ab
    public AudioSource Asharp;
    public AudioSource Csharp;
    public AudioSource Fsharp;
    public AudioSource Gsharp;

    // シーンによって処理を切り替える為に生成時にシーン名を保存しておく
    private String sceneName;
    private void playSound(Color[] selected)
    {
        // 音出力しないモードの場合は終了
        if (Prm.savedataSoundType != 1) return;
        // 選択パネルがンの場合は音を出さないので終了
        if (no == 1 || no == 3 || no == 6 || no == 8 || no == 11) return;
        // マ
        if (no == 10)
        {
            Gsharp.Play();
            return;
        }

        // 自身がガかギか判別
        bool isGA = false;
        if (no == 0 || no == 2 || no == 9) isGA = true;

        // 自身がガorギ内の何番目なのか確認
        int num = 0;
        for (int i = 0; i < selected.Length; i++)
        {
            if (sameColor(selected[i], selected[selected.Length - 1])) num++;
        }

        bool flipFlg = false;
        // この時点でガかギを選んでいるはずなので、selectedの中から一番手前のガギの要素を取得する
        for (int i = 0; i < selected.Length; i++)
        {
            if (sameColor(selected[i], Prm.colorABCD[0]))
            {
                flipFlg = false;
                break;
            }
            if (sameColor(selected[i], Prm.colorABCD[2]))
            {
                flipFlg = true;
                break;
            }
        }
        // もしもガよりも手前にギが来ている場合はガとギの出力音声を差し替える
        if (flipFlg) isGA = !isGA;

        // num番目の音声を出力する
        //ガの場合  1,2はF#      3はG#
        //ギの場合  1はA#        2,3はC#
        if (isGA &&  (num == 1 || num == 2)) Fsharp.Play();
        if (isGA &&   num == 3)              Gsharp.Play();
        if (!isGA &&  num == 1 )             Asharp.Play();
        if (!isGA && (num == 2 || num == 3)) Csharp.Play();
    }
    bool sameColor(Color a,Color b)
    {
        if (a.r != b.r) return false;
        if (a.g != b.g) return false;
        if (a.b != b.b) return false;
        return true;
    }

    // Start is called before the first frame update
    void Start()
    {
        sceneName = SceneManager.GetActiveScene().name;
    }
    public void InitPanelColor()
    {
        if (no == 0 || no == 2 || no == 9) GetComponent<Renderer>().material.color = Prm.colorABCD[0];
        if (no == 1 || no == 3 || no == 6 || no == 8 || no == 11) GetComponent<Renderer>().material.color = Prm.colorABCD[1];
        if (no == 4 || no == 5 || no == 7) GetComponent<Renderer>().material.color = Prm.colorABCD[2];
        if (no == 10) GetComponent<Renderer>().material.color = Prm.colorABCD[3];
    }
    public void InitPanelPattern()
    {
        if (Prm.savedataPatternType == 0)
        {
            Destroy(mark);
            return;
        }
        if (no == 0 || no == 2 || no == 9) ChangePattern(patternRnd + 0);
        if (no == 1 || no == 3 || no == 6 || no == 8 || no == 11) ChangePattern(patternRnd + 1);
        if (no == 4 || no == 5 || no == 7) ChangePattern(patternRnd + 2);
        if (no == 10) ChangePattern(patternRnd + 3);
    }
    private void ChangePattern(int pattern)
    {
        if (pattern % 4 == 0) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_0;
        if (pattern % 4 == 1) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_1;
        if (pattern % 4 == 2) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_2;
        if (pattern % 4 == 3) mark.transform.GetComponent<SpriteRenderer>().sprite = dot_3;
    }


    // Update is called once per frame
    void Update()
    {
    }
    public void SelectPanel()
    {
        PutAndChangeColor();
    }
    public void MouseDown()
    {
        Prm.selectFlg = true;
    }
    public void MouseUp(GameObject g)
    {
        // 既にゲームが終了している場合はフラグだけ直して終了
        if (GameObject.Find("PlayAreaHex") == null)
        {
            Prm.selectFlg = false;
            return;
        }

        PutAndChangeColor();
        if (sceneName == "SoloNomalHex")
        {
            GameObject.Find("BaseSC").GetComponent<BaseSCSoloNomalHex>().CheckAnswer(g);
        }
        else
        {
            GameObject.Find("BaseSC").GetComponent<BaseSCFreeHex>().CheckAnswer();
        }

        Prm.selectFlg = false;
    }
    // 
    public void PutAndChangeColor()
    {

        if (Prm.selectFlg 
            && transform.root.gameObject.transform.root.gameObject.transform.GetComponent<PlayAreaHexSC>().panelLiveHexFlg[y][x] 
            && (AllPanelIsLive() || NearByEndPos()))
        {
            //最初の1枚目の場合startPosに設定
            if (AllPanelIsLive())
            {
                Prm.startPosX = x;
                Prm.startPosY = y;
                transform.root.gameObject.transform.Find("StartPoint").gameObject.transform.position = new Vector3(
                     transform.position.x, transform.position.y, 0);
                transform.root.gameObject.transform.Find("StartPoint").gameObject.SetActive(true);
                //lineの始点を決定
                transform.root.gameObject.GetComponent<LineRenderer>().enabled = true;
                transform.root.gameObject.GetComponent<LineRenderer>().positionCount = 1;
                transform.root.gameObject.GetComponent<LineRenderer>().SetPosition(0, new Vector3(transform.position.x, transform.position.y, 0));

            }
            else //2枚目以降の場合
            {
                transform.root.gameObject.GetComponent<LineRenderer>().positionCount += 1;
                transform.root.gameObject.GetComponent<LineRenderer>().SetPosition(
                    transform.root.gameObject.GetComponent<LineRenderer>().positionCount - 1
                    , new Vector3(transform.position.x, transform.position.y, 0));
            }
            // selectListに追加
            Array.Resize(ref Prm.selectedList, Prm.selectedList.Length + 1);
            Prm.selectedList[Prm.selectedList.Length - 1] = gameObject.GetComponent<Renderer>().material.color;
            // selectedPanelListを活性化＆色更新
            Prm.selectedPanels[Prm.selectedList.Length - 1].GetComponent<Renderer>().enabled = true;
            Prm.selectedPanels[Prm.selectedList.Length - 1].GetComponent<Renderer>().material.color
                = Prm.selectedList[Prm.selectedList.Length - 1];

            // 選択したパネルのフラグ折り＆色変え＆EndPoint更新
            transform.root.gameObject.transform.root.gameObject.transform.GetComponent<PlayAreaHexSC>().panelLiveHexFlg[y][x] = false;
            Prm.endPosX = x;
            Prm.endPosY = y;
            // パネル色を暗くする
            Color.RGBToHSV(gameObject.GetComponent<Renderer>().material.color, out float H, out _, out _);
            gameObject.GetComponent<Renderer>().material.color = Color.HSVToRGB(H, 0.70f, 0.5f);
            //サウンド設定に従い、対象の音を鳴らす
            playSound(Prm.selectedList);
        }
    }

    public bool AllPanelIsLive()
    {
        bool[][] bf = transform.root.gameObject.transform.root.gameObject.transform.GetComponent<PlayAreaHexSC>().panelLiveHexFlg;
        for (int x = 0; x < bf.Length; x++)
        {
            for (int y = 0; y < bf[x].Length; y++)
            {
                if (bf[x][y] == false)
                {
                    return false;
                }
            }
        }
        return true;
    }

    public bool NearByEndPos()
    {
        //  0 1 2
        // 0 1 2 3
        //  0 1 2
        //   0 1
        // 
        if (Prm.endPosX == x && Prm.endPosY == y) return false;
        if (Math.Abs(Prm.endPosY - y) >= 2) return false;
        int a = Prm.endPosX;
        int b = Prm.endPosY;
        if (x == 0 && y == 0 && a == 1 && b == 0) return true;
        if (x == 0 && y == 0 && a == 0 && b == 1) return true;
        if (x == 0 && y == 0 && a == 1 && b == 1) return true;

        if (x == 1 && y == 0 && a == 0 && b == 0) return true;
        if (x == 1 && y == 0 && a == 2 && b == 0) return true;
        if (x == 1 && y == 0 && a == 1 && b == 1) return true;
        if (x == 1 && y == 0 && a == 2 && b == 1) return true;

        if (x == 2 && y == 0 && a == 1 && b == 0) return true;
        if (x == 2 && y == 0 && a == 2 && b == 1) return true;
        if (x == 2 && y == 0 && a == 3 && b == 1) return true;

        if (x == 0 && y == 1 && a == 0 && b == 0) return true;
        if (x == 0 && y == 1 && a == 1 && b == 1) return true;
        if (x == 0 && y == 1 && a == 0 && b == 2) return true;

        if (x == 1 && y == 1 && a == 0 && b == 0) return true;
        if (x == 1 && y == 1 && a == 1 && b == 0) return true;
        if (x == 1 && y == 1 && a == 0 && b == 1) return true;
        if (x == 1 && y == 1 && a == 2 && b == 1) return true;
        if (x == 1 && y == 1 && a == 0 && b == 2) return true;
        if (x == 1 && y == 1 && a == 1 && b == 2) return true;

        if (x == 2 && y == 1 && a == 1 && b == 0) return true;
        if (x == 2 && y == 1 && a == 2 && b == 0) return true;
        if (x == 2 && y == 1 && a == 1 && b == 1) return true;
        if (x == 2 && y == 1 && a == 3 && b == 1) return true;
        if (x == 2 && y == 1 && a == 1 && b == 2) return true;
        if (x == 2 && y == 1 && a == 2 && b == 2) return true;


        if (x == 3 && y == 1 && a == 2 && b == 0) return true;
        if (x == 3 && y == 1 && a == 2 && b == 1) return true;
        if (x == 3 && y == 1 && a == 2 && b == 2) return true;

        if (x == 0 && y == 2 && a == 0 && b == 1) return true;
        if (x == 0 && y == 2 && a == 1 && b == 1) return true;
        if (x == 0 && y == 2 && a == 1 && b == 2) return true;
        if (x == 0 && y == 2 && a == 0 && b == 3) return true;

        if (x == 1 && y == 2 && a == 1 && b == 1) return true;
        if (x == 1 && y == 2 && a == 2 && b == 1) return true;
        if (x == 1 && y == 2 && a == 0 && b == 2) return true;
        if (x == 1 && y == 2 && a == 2 && b == 2) return true;
        if (x == 1 && y == 2 && a == 0 && b == 3) return true;
        if (x == 1 && y == 2 && a == 1 && b == 3) return true;

        if (x == 2 && y == 2 && a == 2 && b == 1) return true;
        if (x == 2 && y == 2 && a == 3 && b == 1) return true;
        if (x == 2 && y == 2 && a == 1 && b == 2) return true;
        if (x == 2 && y == 2 && a == 1 && b == 3) return true;

        if (x == 0 && y == 3 && a == 0 && b == 2) return true;
        if (x == 0 && y == 3 && a == 1 && b == 2) return true;
        if (x == 0 && y == 3 && a == 1 && b == 3) return true;

        if (x == 1 && y == 3 && a == 1 && b == 2) return true;
        if (x == 1 && y == 3 && a == 2 && b == 2) return true;
        if (x == 1 && y == 3 && a == 0 && b == 3) return true;
        return false;
    }

}
